---
---
<!-- HTML header for doxygen 1.8.10-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>TGUI: tgui::DefaultThemeLoader Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<!-- BEGIN CUSTOM 1 -->
<!-- --{{""}}>
{% include head.ext %}
<style>
  div {
    margin-bottom: 0
  }
  #contents {
    padding-left: 0;
    padding-right: 0;
    margin-left: 0;
    margin-right: 0;
    max-width: 1060px;
  }
  address.footer {
    padding-bottom: 1.4em;
  }
</style>
<script type="text/javascript">
function getXPos(item) {
  var x = 0;
  if (item.offsetWidth) {
    while (item && item != document.body && item.id != 'body') {
      x   += item.offsetLeft;
      item = item.offsetParent;
    }
  }
  return x;
}
</script>
<{{""}}!-- -->
<!-- END CUSTOM 1 -->
</head>
<body>
<!-- BEGIN CUSTOM 2 -->
<!-- --{{""}}>
<div id="body" class="NoMargin">
{% include navigation.ext %}
<div id="contents" class="NoMargin">
<{{""}}!-- {% raw %} -->
<!-- END CUSTOM 2 -->
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">TGUI
   &#160;<span id="projectnumber">v0.7-dev</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacetgui.html">tgui</a></li><li class="navelem"><a class="el" href="classtgui_1_1DefaultThemeLoader.html">DefaultThemeLoader</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="classtgui_1_1DefaultThemeLoader-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">tgui::DefaultThemeLoader Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Default implementation for theme loading.  
 <a href="classtgui_1_1DefaultThemeLoader.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="ThemeLoader_8hpp_source.html">ThemeLoader.hpp</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for tgui::DefaultThemeLoader:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classtgui_1_1DefaultThemeLoader.png" usemap="#tgui::DefaultThemeLoader_map" alt=""/>
  <map id="tgui::DefaultThemeLoader_map" name="tgui::DefaultThemeLoader_map">
<area href="classtgui_1_1BaseThemeLoader.html" title="Base class for theme loader implementations. " alt="tgui::BaseThemeLoader" shape="rect" coords="0,0,155,24"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a1f3c4ac552524b1457b3883a7a0a6ee5"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1DefaultThemeLoader.html#a1f3c4ac552524b1457b3883a7a0a6ee5">load</a> (const std::string &amp;filename, const std::string &amp;className, PropertyValuePairs &amp;properties) override</td></tr>
<tr class="memdesc:a1f3c4ac552524b1457b3883a7a0a6ee5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Load the property-value pairs from the theme file.  <a href="#a1f3c4ac552524b1457b3883a7a0a6ee5">More...</a><br /></td></tr>
<tr class="separator:a1f3c4ac552524b1457b3883a7a0a6ee5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classtgui_1_1BaseThemeLoader"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classtgui_1_1BaseThemeLoader')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classtgui_1_1BaseThemeLoader.html">tgui::BaseThemeLoader</a></td></tr>
<tr class="memitem:ab43fb2866b0f51f853446b9bf2c6174c inherit pub_methods_classtgui_1_1BaseThemeLoader"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab43fb2866b0f51f853446b9bf2c6174c"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1BaseThemeLoader.html#ab43fb2866b0f51f853446b9bf2c6174c">~BaseThemeLoader</a> ()=default</td></tr>
<tr class="memdesc:ab43fb2866b0f51f853446b9bf2c6174c inherit pub_methods_classtgui_1_1BaseThemeLoader"><td class="mdescLeft">&#160;</td><td class="mdescRight">Virtual destructor. <br /></td></tr>
<tr class="separator:ab43fb2866b0f51f853446b9bf2c6174c inherit pub_methods_classtgui_1_1BaseThemeLoader"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a9ca655747fb6516a5400e3200fbdc2e9"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1DefaultThemeLoader.html#a9ca655747fb6516a5400e3200fbdc2e9">flushCache</a> (const std::string &amp;filename=&quot;&quot;)</td></tr>
<tr class="memdesc:a9ca655747fb6516a5400e3200fbdc2e9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Empty the caches and force files to be reloaded.  <a href="#a9ca655747fb6516a5400e3200fbdc2e9">More...</a><br /></td></tr>
<tr class="separator:a9ca655747fb6516a5400e3200fbdc2e9"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a1326e3f7aba02004646184b603744d1c"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1DefaultThemeLoader.html#a1326e3f7aba02004646184b603744d1c">readFile</a> (const std::string &amp;filename, std::stringstream &amp;contents) const </td></tr>
<tr class="memdesc:a1326e3f7aba02004646184b603744d1c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reads and return the contents of the entire file.  <a href="#a1326e3f7aba02004646184b603744d1c">More...</a><br /></td></tr>
<tr class="separator:a1326e3f7aba02004646184b603744d1c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Default implementation for theme loading. </p>
<p>Themes are stored on disk in files which contain sections with a syntax similar to CSS. This loader will be able to extract the data from these files.</p>
<p>On first access, the entire file will be cached, the next times the cached map is simply returned. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a9ca655747fb6516a5400e3200fbdc2e9"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void tgui::DefaultThemeLoader::flushCache </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>filename</em> = <code>&quot;&quot;</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Empty the caches and force files to be reloaded. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filename</td><td>File to remove from cache. If no filename is given, the entire cache is cleared. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a1f3c4ac552524b1457b3883a7a0a6ee5"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string tgui::DefaultThemeLoader::load </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>filename</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>className</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">PropertyValuePairs &amp;&#160;</td>
          <td class="paramname"><em>properties</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Load the property-value pairs from the theme file. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filename</td><td>Filename of the theme file </td></tr>
    <tr><td class="paramname">className</td><td>Name of the class inside the theme file (equals widget type when no class is given) </td></tr>
    <tr><td class="paramname">properties</td><td>Empty map op property-value pairs that will be filled by this function</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Type of the widget</dd></dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname"><a class="el" href="classtgui_1_1Exception.html">Exception</a></td><td>when finding syntax errors in the file </td></tr>
    <tr><td class="paramname"><a class="el" href="classtgui_1_1Exception.html">Exception</a></td><td>when file did not contain requested class name </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classtgui_1_1BaseThemeLoader.html#ae1de5c7b76dce92ce979d85447028d3a">tgui::BaseThemeLoader</a>.</p>

</div>
</div>
<a class="anchor" id="a1326e3f7aba02004646184b603744d1c"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void tgui::DefaultThemeLoader::readFile </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>filename</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::stringstream &amp;&#160;</td>
          <td class="paramname"><em>contents</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Reads and return the contents of the entire file. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filename</td><td>Filename of the file to read </td></tr>
    <tr><td class="paramname">contents</td><td>Reference to a stringstream that should be filled with the contents of the file by this function </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>include/TGUI/Loading/<a class="el" href="ThemeLoader_8hpp_source.html">ThemeLoader.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- HTML footer for doxygen 1.8.10-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Sat Nov 25 2017 17:32:43 for TGUI by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.11
</small></address>
<!-- BEGIN CUSTOM 3 -->
<!-- {% endraw %} -{{""}}-{{""}}>
</div>
{% include page_footer.ext %}
</div>
{% include footer.ext %}
<{{""}}!{{""}}-{{""}}- -->
<!-- END CUSTOM 3 -->
</body>
</html>
